package com.syntevo.plugin.jira.transport;

import java.io.*;

/**
 * @author syntevo GmbH
 */
class JiraDebugLoggingOutputStream extends OutputStream {

	// Fields =================================================================

	private OutputStream out;
	private OutputStream log;

	// Setup ==================================================================

	public JiraDebugLoggingOutputStream(OutputStream out, OutputStream logStream) {
		this.out = out;
		this.log = logStream;
	}

	// Implemented ============================================================

	public void write(int b) throws IOException {
		try {
			out.write(b);
		}
		catch (IOException e) {
			throw e;
		}
		finally {
			try {
				log.write(b);
			}
			catch (IOException e) {
			}
		}
	}

	public void close() throws IOException {
		try {
			out.close();
		}
		catch (IOException e) {
			throw e;
		}
		finally {
			try {
				log.close();
			}
			catch (IOException e) {
			}
		}
	}

	public void flush() throws IOException {
		try {
			out.flush();
		}
		catch (IOException e) {
			throw e;
		}
		finally {
			try {
				log.flush();
			}
			catch (IOException e) {
			}
		}
	}

	public void write(byte[] b, int off, int len) throws IOException {
		try {
			out.write(b, off, len);
		}
		catch (IOException e) {
			throw e;
		}
		finally {
			try {
				log.write(b, off, len);
			}
			catch (IOException e) {
			}
		}
	}

	// Accessing ==============================================================

	public void flushBuffer() {
		try {
			log.flush();
		}
		catch (IOException e) {
		}
	}
}