package com.syntevo.plugin.mergeinfocolumn;

import org.tmatesoft.svn.core.*;
import org.tmatesoft.svn.core.wc.*;

import com.syntevo.openapi.smartsvn.file.gui.*;

/**
 * @author syntevo GmbH
 */
final class MergeInfoFileFilter implements ISvnFileFilter {

	// Implemented ============================================================

	public boolean handleProperty(SvnFileExtendedAttributesBuilder attributes, String key, SVNPropertyValue value) {
		if (!SVNProperty.MERGE_INFO.equals(key)) {
			return false;
		}

		attributes.setAttribute(SVNProperty.MERGE_INFO, MergeInfoType.stringToInternal(value.getString()));
		return true;
	}

	public String getFilterName() {
		return "Merge Info";
	}

	public boolean doesMatch(SvnFileExtendedAttributes attributes, String text, boolean regularExpression) {
		if (text == null) {
			text = "";
		}
		
		final MergeInfoType mergeInfo = (MergeInfoType)attributes.getAttribute(SVNProperty.MERGE_INFO);
		if (mergeInfo == null) {
			return "".equals(text);
		}
		return text.toLowerCase().equals(mergeInfo.getName().toLowerCase());
	}
}